<template>
  <nav>
    <ul class="inline-flex dark:text-zinc-300">
      <li v-show="currentPage > 1">
        <router-link
          class="py-2 px-3 ml-0 leading-tight text-gray-500 bg-white rounded-l-lg border border-gray-300 hover:bg-gray-100 hover:text-gray-700 dark:bg-gray-800 dark:border-gray-700 dark:text-gray-400 dark:hover:bg-gray-700 dark:hover:text-white dark:text-zinc-300"
          :to="{ ...$route, query: { ...$route.query, page: currentPage - 1 } }"
        >
          {{ $gettext('Previous page') }}
        </router-link>
      </li>

      <li v-for="page in pages" :key="page">
        <router-link
          v-if="page === currentPage"
          class="py-2 px-3 text-blue-600 bg-blue-50 border border-gray-300 hover:bg-blue-100 hover:text-blue-700 dark:border-gray-700 dark:bg-gray-700 dark:text-white"
          :class="{
            'rounded-l-lg': currentPage === 1,
            'rounded-r-lg': currentPage >= maxPage,
          }"
          :to="{ query: buildPageUrlQuery(page) }"
          :aria-current="page"
        >
          {{ page }}
        </router-link>
        <router-link
          v-else
          class="hidden sm:inline py-2 px-3 leading-tight text-gray-500 bg-white border border-gray-300 hover:bg-gray-100 hover:text-gray-700 dark:bg-gray-800 dark:border-gray-700 dark:text-gray-400 dark:hover:bg-gray-700 dark:hover:text-white"
          :to="{ query: buildPageUrlQuery(page) }"
        >
          {{ page }}
        </router-link>
      </li>

      <li v-show="currentPage < maxPage">
        <router-link
          class="py-2 px-3 ml-0 leading-tight text-gray-500 bg-white rounded-r-lg border border-gray-300 hover:bg-gray-100 hover:text-gray-700 dark:bg-gray-800 dark:border-gray-700 dark:text-gray-400 dark:hover:bg-gray-700 dark:hover:text-white dark:text-zinc-300"
          :to="{ ...$route, query: { ...$route.query, page: currentPage + 1 } }"
        >
          {{ $gettext('Next page') }}
        </router-link>
      </li>
    </ul>
  </nav>
</template>

<script setup lang="ts">
  import { useRoute } from 'vue-router'

  defineProps({
    maxPage: {
      type: Number,
      required: true,
    },
    currentPage: {
      type: Number,
      required: true,
    },
    pages: {
      type: Array as () => number[],
      required: true,
    },
  })

  const route = useRoute()

  function buildPageUrlQuery(page: number) {
    const query = route.query

    return Object.assign({}, query, { page })
  }
</script>
